Deadpool = LibStub("AceAddon-3.0"):NewAddon("Dead Pool", "AceConsole-3.0", "AceEvent-3.0", "AceComm-3.0", "AceSerializer-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("Deadpool", true)
local AceGUI = LibStub("AceGUI-3.0")

DeadpoolGlobal_CommPrefix = "Deadpool"

local deadpoolFramePool = {}
DeadpoolGlobal_BetweenObjectsGap = 11

local DEADPOOL_NUM_LINES = 10
local DEADPOOL_LINE_WIDTH = 96

local DEADPOOL_COL1_WIDTH = 110 -- + Portrait !
local DEADPOOL_COL2_WIDTH = 4*32 + 5
local DEADPOOL_COL4_WIDTH = 40
local DEADPOOL_ALLCOLS_WIDTH = DEADPOOL_COL1_WIDTH -- + Portrait !
	+ DEADPOOL_COL2_WIDTH
	+ DEADPOOL_COL4_WIDTH

local deadpoolList = {}
local deadpoolLines = {}

function Deadpool:OnInitialize()
	-- Called when the addon is loaded
end

function Deadpool:OnEnable()
	--Deadpool:Print("Activated")
    if not DeadpoolFrame then
        --Deadpool:Print("Frame loading")
        loadDeadpoolOptions()
        initDeadpoolBusinessObjects()
        
		--NewDeadpoolFrame
		DeadpoolFrame = CreateFrame("Frame", "DeadpoolFrame", UIParent, "DeadpoolFrameTemplate")
		DeadpoolFrame:SetHitRectInsets(-10, -10, -10, -10)
		DeadpoolFrame:SetAlpha(DeadpoolOptionsData["DeadpoolFrameAlpha"])
        DeadpoolFrame:SetWidth(DEADPOOL_ALLCOLS_WIDTH + 24 + 30)
		if DeadpoolPosition then
            DeadpoolFrame:SetPoint(DeadpoolPosition["point"], DeadpoolPosition["relativeTo"],
				DeadpoolPosition["relativePoint"], DeadpoolPosition["xOffset"], DeadpoolPosition["yOffset"])
        end
        
        local fontstring = DeadpoolFrame:CreateFontString("DeadpoolLabel", "ARTWORK", "DeadpoolWindowTitleTemplate")
        fontstring:SetText("Dead Pool".." "..GetAddOnMetadata("Deadpool", "Version"))
        fontstring:SetPoint("TOP", 0, -1)
        
        local announceDeadpoolSessionButton = createAnnounceDeadpoolSessionButton(DeadpoolFrame)

		local deadpoolOptionsButton = createDeadpoolOptionsButton(DeadpoolFrame)
        local deadpoolSearchBox = createDeadpoolSearchBox(DeadpoolFrame)

		local columnsTitle1 = CreateFrame("Button", "DeadpoolColumnsTitle1Frame", DeadpoolFrame, "DeadpoolColumnHeaderTemplate")
		columnsTitle1:SetPoint("TOPLEFT", 2, -23)
        columnsTitle1:SetText(L["DEADPOOLCOLLUMNS_CHARACTER"])
		WhoFrameColumn_SetWidth(columnsTitle1, DEADPOOL_COL1_WIDTH + 30)
		columnsTitle1.sortType = "character"

		local columnsTitle2 = CreateFrame("Button", "DeadpoolColumnsTitle2Frame", DeadpoolFrame, "DeadpoolColumnHeaderTemplate")
		columnsTitle2:SetPoint("LEFT", columnsTitle1, "RIGHT", -2, 0)
        columnsTitle2:SetText(L["DEADPOOLCOLLUMNS_NEXTDEATHBETS"])
		WhoFrameColumn_SetWidth(columnsTitle2, DEADPOOL_COL2_WIDTH)
		columnsTitle2.sortType = "nbDeathBets"

		local columnsTitle4 = CreateFrame("Button", "DeadpoolColumnsTitle4Frame", DeadpoolFrame, "DeadpoolColumnHeaderTemplate")
		columnsTitle4:SetPoint("LEFT", columnsTitle2, "RIGHT", -2, 0)
        columnsTitle4:SetText(L["DEADPOOLCOLLUMNS_ODDS"])
		WhoFrameColumn_SetWidth(columnsTitle4, DEADPOOL_COL4_WIDTH)
		columnsTitle4.sortType = "odds"

		DeadpoolFrameSummaryButton:SetPoint("LEFT", columnsTitle4, "RIGHT", 0, 0)

		local scrollFrame = CreateFrame("ScrollFrame", "DeadpoolScrollFrame",
			_G[DeadpoolFrame:GetName().."InsideFrame"], "FauxScrollFrameTemplate")
		scrollFrame:SetAllPoints(_G[DeadpoolFrame:GetName().."InsideFrame"])
		scrollFrame:SetPoint("TOPLEFT", _G[DeadpoolFrame:GetName().."InsideFrame"] ,"TOPLEFT", 0, -5)
		scrollFrame:SetPoint("BOTTOMRIGHT", _G[DeadpoolFrame:GetName().."InsideFrame"] ,"BOTTOMRIGHT", -27, 3)
		scrollFrame:SetScript("OnVerticalScroll", function(self, offset)
			FauxScrollFrame_OnVerticalScroll(self, offset, DeadpoolOptionsData["DeadpoolLigneHeight"], Deadpool_UpdateScrollFrame)
		end)
 
		for i = 1, DEADPOOL_NUM_LINES do
			local line = CreateFrame("Button", "DeadpoolLine"..i, scrollFrame:GetParent(), "DeadpoolLineTemplate")
			if i == 1 then
				line:SetPoint("TOPLEFT", scrollFrame, 3, 0)
			else
				line:SetPoint("TOPLEFT", deadpoolLines[i - 1], "BOTTOMLEFT")
			end
			line:SetSize(scrollFrame:GetParent():GetWidth() - 29, DeadpoolOptionsData["DeadpoolLigneHeight"])
			line:Hide()
			deadpoolLines[i] = line
		end
		
		self:RegisterChatCommand("deadpool", "DeadpoolShow")
        self:RegisterComm(DeadpoolGlobal_CommPrefix, "ReceiveDataFrame_OnEvent")
        Deadpool:Print(L["DEADPOOL_WELCOME"])
    end

	-- Called when the addon is enabled
    self:RegisterEvent("GROUP_ROSTER_UPDATE", "ReloadData")
    self:RegisterEvent("RAID_TARGET_UPDATE", "ReloadData")
	self:RegisterEvent("UNIT_HEALTH", "CheckDeath")
	self:RegisterEvent("PLAYER_ENTERING_WORLD", "CallForDeadpoolData")
	self:RegisterEvent("ADDON_LOADED", "CallForDeadpoolData")
	self:RegisterEvent("GROUP_JOINED", "CallForDeadpoolData")
	Deadpool:ReloadData()
end

function Deadpool:ReloadData()
	local numGroupMembers = GetNumGroupMembers()
	if numGroupMembers == 0 then
		playerJoinsDeadpoolSession("DeadpoolSession_"..Deadpool_playerCharacter(), true, true)
	end
	generateDeadpoolTable()
end

function Deadpool:DeadpoolShow(input)
	generateDeadpoolTable()
	DeadpoolFrame:Show()
	tellTutorialText("DEADPOOLTUTO_TUTO1")
end

function Deadpool:CheckDeath()
	local numGroupMembers = GetNumGroupMembers()
	if numGroupMembers > 0 then
		for i = 1, numGroupMembers do
			local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(i)
			name = Deadpool_addRealm(name)
			local isAlreadyDead = getDeadpoolData(DeadpoolGlobal_SessionId, name, "isAlreadyDead")
			if name then
				if isDead then
					if not isAlreadyDead or isAlreadyDead == "false" then
						deadpoolCharacterIsDead(DeadpoolGlobal_SessionId, name)
						setDeadpoolData(DeadpoolGlobal_SessionId, name, "isAlreadyDead", "true")
					end
				else
					setDeadpoolData(DeadpoolGlobal_SessionId, name, "isAlreadyDead", "false")
				end
				local groupRank = getDeadpoolCharInfo(name, "groupRank")
				if groupRank then
					if UnitAffectingCombat(groupRank) then
						setDeadpoolData(DeadpoolGlobal_SessionId, name, "inCombat", "true")
					else
						setDeadpoolData(DeadpoolGlobal_SessionId, name, "inCombat", "false")
					end
				end
			end
		end
	else
		local name = Deadpool_playerCharacter()
		local isDead = UnitIsDead("player")
		local isAlreadyDead = getDeadpoolData(DeadpoolGlobal_SessionId, name, "isAlreadyDead")
		if name then
			if isDead then
				if not isAlreadyDead or isAlreadyDead == "false" then
					deadpoolCharacterIsDead(DeadpoolGlobal_SessionId, name)
					setDeadpoolData(DeadpoolGlobal_SessionId, name, "isAlreadyDead", "true")
				end
			else
				setDeadpoolData(DeadpoolGlobal_SessionId, name, "isAlreadyDead", "false")
			end
			if UnitAffectingCombat("player") then
				setDeadpoolData(DeadpoolGlobal_SessionId, name, "inCombat", "true")
			else
				setDeadpoolData(DeadpoolGlobal_SessionId, name, "inCombat", "false")
			end
		end
	end
end

function deadpoolCharacterIsDead(aDeadpoolSessionId, aChar)
	local totalNextDeathBets, nbNextDeathBets = getDeadpoolTotalBets(aDeadpoolSessionId, "nextDeathBet")
	local totalUniqueGambleOnChar, totalUniqueGamble = getDeadpoolTotalUniqueGamble(aDeadpoolSessionId, aChar)
	if totalNextDeathBets > 0 or totalUniqueGamble > 0 then
		local tooltip = L["DEADPOOLUI_RESULTS"]
		local tooltipDetail = {}
		local tooltipDetailGreen = {}
		local tooltipDetailRed = {}
		local deadpoolLog = nil
		local totalNextDeathBetsOnChar, nbNextDeathBetsOnChar = getDeadpoolTotalBets(aDeadpoolSessionId, "nextDeathBet", aChar)
		local bankCredits = getDeadpoolData(aDeadpoolSessionId, "Bank", "credits")
		bankCredits = Deadpool_tonumberzeroonblankornil(bankCredits)

		local _, _, totalBets = getDeadpoolBets(aDeadpoolSessionId, aChar)
		local uniqueGamble = getDeadpoolData(aDeadpoolSessionId, Deadpool_playerCharacter(), "uniqueGamble")
		if (uniqueGamble and uniqueGamble ~= "")
			or totalBets > 0 then
			Deadpool_PlaySoundKitID(41361)
			tellTutorialText("DEADPOOLTUTO_TUTO3", true)
		end
		local bankWins = true
		local bankLoses = false
		local dataTime = tostring(Deadpool_getTimeUTCinMS())
		if aDeadpoolSessionId and aChar and DeadpoolData
			and DeadpoolData[aDeadpoolSessionId] then
			local shortName = Deadpool_delRealm(aChar)
			deadpoolLog = shortName..L["DEADPOOLLOGS_DIED"]
			Deadpool:Print(deadpoolLog)
			Deadpool.ToastFakeAchievement(deadpoolLog, 3456)
			table.insert(tooltipDetail, deadpoolLog)
			for k1 in pairs(DeadpoolData[aDeadpoolSessionId]) do
				shortName = Deadpool_delRealm(k1)
				local bets = DeadpoolData[aDeadpoolSessionId][k1]["bets"]
				uniqueGamble = getDeadpoolData(aDeadpoolSessionId, k1, "uniqueGamble")
				local playerBets = 0
				local playerActualCredits = getDeadpoolData(aDeadpoolSessionId, k1, "credits")
				local deadpoolGain_ = 0
				if bets then
					for k2 in pairs(bets) do
						local playerNextDeathBetsOnChar = getDeadpoolPlayerBetsOnChar(aDeadpoolSessionId, "nextDeathBet", k1, k2)
						playerBets = playerBets + playerNextDeathBetsOnChar
						if k2 == aChar and playerNextDeathBetsOnChar > 0 then
							deadpoolGain_ = deadpoolGain(totalNextDeathBets, playerNextDeathBetsOnChar, totalNextDeathBetsOnChar)
							deadpoolLog = shortName..L["DEADPOOLLOGS_WINS"]..deadpoolGain_..string.format(L["DEADPOOLLOGS_CHIPS"], deadpoolChipTextureString)
							Deadpool:Print(deadpoolLog)
							table.insert(tooltipDetailGreen, deadpoolLog)
							bankWins = false
						end
						bets[k2]["nextDeathBet"] = nil
						bets[k2]["dataTime"] = dataTime
					end
				end
				if uniqueGamble and uniqueGamble ~= "" then
					if bankCredits > 0 and uniqueGamble == aChar then
						local deadpoolBankGain = deadpoolGain(bankCredits, 1, totalUniqueGambleOnChar)
						deadpoolLog = shortName..L["DEADPOOLLOGS_WINS"]..deadpoolBankGain..string.format(L["DEADPOOLLOGS_BANKCHIPS"], deadpoolChipTextureString)
						deadpoolGain_ = deadpoolGain_ + deadpoolBankGain
						Deadpool:Print(deadpoolLog)
						table.insert(tooltipDetailRed, deadpoolLog)
						bankLoses = true
					end
					setDeadpoolData(aDeadpoolSessionId, k1, "uniqueGamble", "")
				end
				if deadpoolGain_ > 0 then
					setDeadpoolData(aDeadpoolSessionId, k1, "credits", playerActualCredits + deadpoolGain_)
				end
				if aChar == k1 and playerBets > 0 then
					Deadpool_dropAnItem(aChar, 1, true)
					deadpoolLog = string.format(L["DEADPOOLLOGS_HASBETANDDIED"], Deadpool_delRealm(aChar))
					Deadpool:Print(deadpoolLog)
					table.insert(tooltipDetailRed, deadpoolLog)
				end
			end
		end
		if bankLoses then
			bankCredits = 0
		end
		if bankWins and totalNextDeathBets > 0 then
			bankCredits = bankCredits + totalNextDeathBets
			deadpoolLog = L["DEADPOOLLOGS_THEBANK"]..L["DEADPOOLLOGS_WINS"]..totalNextDeathBets..string.format(L["DEADPOOLLOGS_CHIPS"], deadpoolChipTextureString)
			Deadpool:Print(deadpoolLog)
			table.insert(tooltipDetailRed, deadpoolLog)
		end
		setDeadpoolData(aDeadpoolSessionId, "Bank", "credits", bankCredits)
		DeadpoolResultsTooltip:SetAttribute("tooltip", tooltip)
		DeadpoolResultsTooltip:SetAttribute("tooltipDetail", tooltipDetail)
		DeadpoolResultsTooltip:SetAttribute("tooltipDetailGreen", tooltipDetailGreen)
		DeadpoolResultsTooltip:SetAttribute("tooltipDetailRed", tooltipDetailRed)
		DeadpoolShowResults()
		generateDeadpoolTable()
	end
end

function showDeadpoolPlayerDetails(self)
	if not DeadpoolSummaryFrame:IsShown() then
		DeadpoolFrameSummaryButton_Onclick()
	end
	--PanelTemplates_SetTab(DeadpoolSummaryFrame, 2)
	--PanelTemplates_Tab_OnClick(DeadpoolSummaryFrameTab2, DeadpoolSummaryFrame)
	selectedDeadpoolCharacter = self:GetAttribute("fullName")
	DeadpoolSummaryFrame_Update()
	Deadpool_PlaySound("igMainMenuOptionCheckBoxOn")
end

function deadpoolUndressModel(modelFrame, offItemsNumber)
	modelFrame:UndressSlot(19) -- Tabard
	modelFrame:UndressSlot(4) -- Body
	
	if offItemsNumber then
		local numberOfSlots = Deadpool_countTableElements(deadpoolUndressingOrder)
		if offItemsNumber > numberOfSlots then
			offItemsNumber = numberOfSlots
		end
		for i = 1, offItemsNumber do
			modelFrame:UndressSlot(deadpoolUndressingOrder[i])
		end
	end
end

function DeadpoolOptionsButtonClick(self)
	InterfaceOptionsFrame_OpenToCategory("Dead Pool")
	InterfaceOptionsFrame_OpenToCategory("Dead Pool")
	checkDeadpoolVersion()
end

function AnnounceDeadpoolSessionButton_OnClick()
	if DeadpoolResultsTooltip:IsShown() then
		DeadpoolResultsTooltip:Hide()
	else
		DeadpoolShowResults()
	end
end

function DeadpoolIconButtonEnter(self)
	local tooltip = self:GetAttribute("tooltip")
	local tooltipDetail = self:GetAttribute("tooltipDetail")
	local tooltipDetailGreen = self:GetAttribute("tooltipDetailGreen")
	local tooltipDetailRed = self:GetAttribute("tooltipDetailRed")
	DeadpoolTooltip:SetOwner(self, "ANCHOR_TOPRIGHT")
	DeadpoolTooltip:SetText(tooltip)
	if tooltipDetail then
		for index,value in pairs(tooltipDetail) do
			DeadpoolTooltip:AddLine(value, 1.0, 1.0, 1.0)
		end
	end
	if tooltipDetailGreen then
		for index,value in pairs(tooltipDetailGreen) do
			DeadpoolTooltip:AddLine(value, 0.0, 1.0, 0.0)
		end
	end
	if tooltipDetailRed then
		for index,value in pairs(tooltipDetailRed) do
			DeadpoolTooltip:AddLine(value, 1.0, 0.0, 0.0)
		end
	end
	DeadpoolTooltip:Show()
end

function DeadpoolShowResults()
	local tooltip = DeadpoolResultsTooltip:GetAttribute("tooltip")
	local tooltipDetail = DeadpoolResultsTooltip:GetAttribute("tooltipDetail")
	local tooltipDetailGreen = DeadpoolResultsTooltip:GetAttribute("tooltipDetailGreen")
	local tooltipDetailRed = DeadpoolResultsTooltip:GetAttribute("tooltipDetailRed")
	if tooltip and (Deadpool_countTableElements(tooltipDetail) > 0 or Deadpool_countTableElements(tooltipDetailGreen) > 0) then
		DeadpoolResultsTooltip:SetOwner(DeadpoolFrame, "ANCHOR_BOTTOM")
		DeadpoolResultsTooltip:SetText(tooltip)
		if tooltipDetail then
			for index,value in pairs(tooltipDetail) do
				DeadpoolResultsTooltip:AddLine(value, 1.0, 1.0, 1.0)
			end
		end
		if tooltipDetailGreen then
			for index,value in pairs(tooltipDetailGreen) do
				DeadpoolResultsTooltip:AddLine(value, 0.0, 1.0, 0.0)
			end
		end
		if tooltipDetailRed then
			for index,value in pairs(tooltipDetailRed) do
				DeadpoolResultsTooltip:AddLine(value, 1.0, 0.0, 0.0)
			end
		end
		DeadpoolResultsTooltip:Show()
	end
end

function DeadpoolIconButtonLeave(self)
	DeadpoolTooltip:Hide()
end

function getFontStringFromDeadpoolFramePool(id, name, template, deadpoolLine)
	if not deadpoolFramePool[id] then
		deadpoolFramePool[id] = {}
	end
	if not deadpoolFramePool[id][name] then
		deadpoolFramePool[id][name] = _G[deadpoolLine:GetName()]:CreateFontString(name, "ARTWORK", template)
	end
	return deadpoolFramePool[id][name]
end

function getElementFromDeadpoolFramePool(type, id, name, template, parent, columnNumber)
	local elementName = name
	if columnNumber then
		elementName = columnNumber
	end
	if not deadpoolFramePool[id] then
		deadpoolFramePool[id] = {}
	end
	if not deadpoolFramePool[id][elementName] then
		deadpoolFramePool[id][elementName] = CreateFrame(type, name, _G[parent], template)
	end
	return deadpoolFramePool[id][elementName]
end

function createDeadpoolLine(aDeadpoolSessionId, indexCharac, fullName, deadpoolLine)

	deadpoolLine:SetAttribute("fullName", fullName)

	if selectedDeadpoolLine and fullName == selectedDeadpoolCharacter then
		selectedDeadpoolLine = deadpoolLine
		deadpoolLine.Selected:Show()
	else
		deadpoolLine.Selected:Hide()
	end
	
	local xValue = DeadpoolGlobal_BetweenObjectsGap
	local roleButton, role = createDeadpoolRoleButton(aDeadpoolSessionId, fullName, indexCharac, xValue, deadpoolLine)

	xValue = roleButton:GetWidth() + 2*DeadpoolGlobal_BetweenObjectsGap
	local fontstring = getFontStringFromDeadpoolFramePool(indexCharac, "PlayerLabel", "DeadpoolPlayerLabelTemplate", deadpoolLine)
	local color = RAID_CLASS_COLORS[deadpoolCharInfo[fullName]["classFileName"]]
	fontstring:SetTextColor(color.r, color.g, color.b, 1.0)
	fontstring:SetText(Deadpool_delRealm(fullName))
	fontstring:SetPoint("LEFT", xValue, 0)
	fontstring:SetWidth(85 + 30 - DeadpoolOptionsData["DeadpoolLigneHeight"])
	
	xValue = xValue + PlayerLabel:GetWidth()
	local playerCharacter = Deadpool_playerCharacter()
	local totalNextDeathBets, nbNextDeathBets = getDeadpoolTotalBets(aDeadpoolSessionId, "nextDeathBet")
	local totalNextDeathBetsOnChar, nbNextDeathBetsOnChar = getDeadpoolTotalBets(aDeadpoolSessionId, "nextDeathBet", fullName)
	local playerNextDeathBetsOnChar = getDeadpoolPlayerBetsOnChar(aDeadpoolSessionId, "nextDeathBet", playerCharacter, fullName)
	local nbOf5 = floor(nbNextDeathBetsOnChar/5)
	local rest = nbNextDeathBetsOnChar - (5*nbOf5)
	for i = 1, 4 do
		local deadpoolBetCount = getElementFromDeadpoolFramePool("Frame", indexCharac,
			"DeadpoolBetCount"..indexCharac.."_"..i, "DeadpoolBetCountTemplate", deadpoolLine:GetName())
		deadpoolBetCount:SetPoint("LEFT", xValue, 0)
		deadpoolBetCount:SetHeight(DeadpoolOptionsData["DeadpoolLigneHeight"])
		deadpoolBetCount:Show()
		local deadpoolBetCountTexture = _G["DeadpoolBetCount"..indexCharac.."_"..i.."Texture"]
		deadpoolBetCountTexture:SetHeight(DeadpoolOptionsData["DeadpoolLigneHeight"])
		if i <= nbOf5 then
			deadpoolBetCountTexture:SetTexture("Interface\\AddOns\\Deadpool\\art\\count5")
		else
			if i == nbOf5 + 1 and rest > 0 then
				deadpoolBetCountTexture:SetTexture("Interface\\AddOns\\Deadpool\\art\\count"..tostring(rest))
			else
				deadpoolBetCount:Hide()
			end
		end
		xValue = xValue + deadpoolBetCount:GetWidth()
	end
	xValue = xValue + 3

	local odds = deadpoolOdds(totalNextDeathBets, totalNextDeathBetsOnChar)
	local oddsInfoFrame = getElementFromDeadpoolFramePool("Button", indexCharac,
		"DeadpoolOddsInfoFrame"..indexCharac, "DeadpoolBetsOddsInfoTemplate", deadpoolLine:GetName())
	local betsOnCharVstotalBets = odds / totalNextDeathBets
	_G["DeadpoolOddsInfoFrame"..indexCharac.."_ChipPile1"]:Hide()
	_G["DeadpoolOddsInfoFrame"..indexCharac.."_ChipPile2"]:Hide()
	_G["DeadpoolOddsInfoFrame"..indexCharac.."_ChipPile3"]:Hide()
	_G["DeadpoolOddsInfoFrame"..indexCharac.."_ChipPile4"]:Hide()
	_G["DeadpoolOddsInfoFrame"..indexCharac.."_ChipPile5"]:Hide()
	_G["DeadpoolOddsInfoFrame"..indexCharac.."_ChipPile1Green"]:Hide()
	_G["DeadpoolOddsInfoFrame"..indexCharac.."_ChipPile2Green"]:Hide()
	_G["DeadpoolOddsInfoFrame"..indexCharac.."_ChipPile3Green"]:Hide()
	_G["DeadpoolOddsInfoFrame"..indexCharac.."_ChipPile4Green"]:Hide()
	_G["DeadpoolOddsInfoFrame"..indexCharac.."_ChipPile5Green"]:Hide()
	_G["DeadpoolOddsInfoFrame"..indexCharac.."_ChipPile1Red"]:Hide()
	_G["DeadpoolOddsInfoFrame"..indexCharac.."_ChipPile2Red"]:Hide()
	_G["DeadpoolOddsInfoFrame"..indexCharac.."_ChipPile3Red"]:Hide()
	_G["DeadpoolOddsInfoFrame"..indexCharac.."_ChipPile4Red"]:Hide()
	_G["DeadpoolOddsInfoFrame"..indexCharac.."_ChipPile5Red"]:Hide()
	oddsInfoFrame.Flash1Anim:Stop();
	oddsInfoFrame.Flash2Anim:Stop();
	oddsInfoFrame.Flash3Anim:Stop();
	oddsInfoFrame.Flash4Anim:Stop();
	oddsInfoFrame.Flash5Anim:Stop();
	local chipPileSize = DeadpoolOptionsData["DeadpoolLigneHeight"] - 4
	local chipPileToShow = nil
	if betsOnCharVstotalBets < 0.20 then
		chipPileToShow = "DeadpoolOddsInfoFrame"..indexCharac.."_ChipPile1"
	elseif betsOnCharVstotalBets < 0.40 then
		chipPileToShow = "DeadpoolOddsInfoFrame"..indexCharac.."_ChipPile2"
	elseif betsOnCharVstotalBets < 0.60 then
		chipPileToShow = "DeadpoolOddsInfoFrame"..indexCharac.."_ChipPile3"
	elseif betsOnCharVstotalBets < 0.80 then
		chipPileToShow = "DeadpoolOddsInfoFrame"..indexCharac.."_ChipPile4"
	else
		chipPileToShow = "DeadpoolOddsInfoFrame"..indexCharac.."_ChipPile5"
	end

	if playerNextDeathBetsOnChar > 0 then
		_G[chipPileToShow.."Green"]:Show()
		_G[chipPileToShow.."Green"]:SetSize(chipPileSize, chipPileSize)
	else
		_G[chipPileToShow]:Show()
		_G[chipPileToShow]:SetSize(chipPileSize, chipPileSize)
	end

	oddsInfoFrame:SetPoint("LEFT", xValue, 0)
	oddsInfoFrame:SetAttribute("tooltip", L["DEADPOOLCOLLUMNS_ODDS"])
	local oddsLib = string.format("%.1f", odds)
	oddsInfoFrame:SetAttribute("tooltipDetail", { L["DEADPOOLUI_BET"], L["DEADPOOLUI_BET2"]..oddsLib..L["DEADPOOLUI_BET3"] })
	if playerNextDeathBetsOnChar > 0 then
		oddsInfoFrame:SetAttribute("tooltipDetailGreen", { string.format(L["DEADPOOLUI_BET7"], playerNextDeathBetsOnChar, deadpoolChipTextureString), 
			L["DEADPOOLUI_BET4"]..playerNextDeathBetsOnChar.." x "..oddsLib })
	else
		oddsInfoFrame:SetAttribute("tooltipDetailGreen", { L["DEADPOOLUI_BET5"] })
	end
	oddsInfoFrame:SetAttribute("Character", fullName)

	local uniqueGamble = getDeadpoolData(aDeadpoolSessionId, playerCharacter, "uniqueGamble")
	if uniqueGamble and uniqueGamble == fullName then
		_G[chipPileToShow.."Red"]:Show()
		_G[chipPileToShow.."Red"]:SetSize(chipPileSize, chipPileSize)
		oddsInfoFrame.Flash1Anim:Play()
		oddsInfoFrame.Flash2Anim:Play()
		oddsInfoFrame.Flash3Anim:Play()
		oddsInfoFrame.Flash4Anim:Play()
		oddsInfoFrame.Flash5Anim:Play()
		oddsInfoFrame:SetAttribute("tooltipDetailRed", { L["DEADPOOLUI_BET6"] })
	else
		oddsInfoFrame:SetAttribute("tooltipDetailRed", nil)
	end

	if not DeadpoolOptionsData["TutoDisabled"]
		and (not DeadpoolTuto
			or not DeadpoolTuto["chipPiles"]) then
		oddsInfoFrame.Flash:Show();
		oddsInfoFrame.FlashAnim:Play();
	else
		oddsInfoFrame.Flash:Hide();
		oddsInfoFrame.FlashAnim:Stop();
	end
	
	deadpoolLine:SetWidth(DEADPOOL_ALLCOLS_WIDTH - 8 + 30)
end

function deadpoolOdds(totalNextDeathBets, totalNextDeathBetsOnChar)
	return Deadpool_nozero(totalNextDeathBets / Deadpool_nozero(totalNextDeathBetsOnChar))
end

function deadpoolGain(totalNextDeathBets, playerNextDeathBetsOnChar, totalNextDeathBetsOnChar)
	return floor(deadpoolOdds(totalNextDeathBets, totalNextDeathBetsOnChar) * playerNextDeathBetsOnChar)
end

function Deadpool_nozero(aNumber)
	if aNumber == 0 then
		return 1
	end
	return aNumber
end

function getDeadpoolPlayerBetsOnChar(aDeadpoolSessionId, aBetType, aPlayer, aChar)
	local playerBetsOnChar = 0
	if aDeadpoolSessionId and aBetType and aPlayer and aChar and DeadpoolData
		and DeadpoolData[aDeadpoolSessionId] then
		for k1 in pairs(DeadpoolData[aDeadpoolSessionId]) do
			if k1 == aPlayer then
				local bets = DeadpoolData[aDeadpoolSessionId][k1]["bets"]
				if bets then
					for k2 in pairs(bets) do
						if k2 == aChar then
							playerBetsOnChar = Deadpool_tonumberzeroonblankornil(bets[k2][aBetType])
						end
					end
				end
			end
		end
	end
	return playerBetsOnChar
end

function getDeadpoolTotalBets(aDeadpoolSessionId, aBetType, aChar)
	local totalBets = 0
	local nbBets = 0
	if aDeadpoolSessionId and aBetType and DeadpoolData
		and DeadpoolData[aDeadpoolSessionId] then
		for k1 in pairs(DeadpoolData[aDeadpoolSessionId]) do
			local bets = DeadpoolData[aDeadpoolSessionId][k1]["bets"]
			if bets then
				for k2 in pairs(bets) do
					local betCredits = bets[k2][aBetType]
					if betCredits
						and (not aChar or aChar == k2)then
						local betCreditsValue = Deadpool_tonumberzeroonblankornil(betCredits)
						totalBets = totalBets + betCreditsValue
						if betCreditsValue > 0 then
							nbBets = nbBets + 1
						end
					end
				end
			end
		end
	end
	return totalBets, nbBets
end

function getDeadpoolTotalUniqueGamble(aDeadpoolSessionId, aChar)
	local totalBetsOnChar = 0
	local totalBets = 0
	if aDeadpoolSessionId and aChar and DeadpoolData
		and DeadpoolData[aDeadpoolSessionId] then
		for k1 in pairs(DeadpoolData[aDeadpoolSessionId]) do
			local uniqueGamble = getDeadpoolData(aDeadpoolSessionId, k1, "uniqueGamble")
			if uniqueGamble and uniqueGamble ~= "" then
				totalBets = totalBets + 1
				if uniqueGamble == aChar then
					totalBets = totalBets + 1
				end
			end
		end
	end
	return totalBetsOnChar, totalBets
end

function Deadpool_isPlayerCharacter(aName)
	return Deadpool_playerCharacter() == Deadpool_addRealm(aName)
end

function Deadpool_playerCharacter()
	playerName, playerRealm = UnitFullName("player")
	return Deadpool_addRealm(playerName, playerRealm)
end

function ValidateDeadpoolBetButton_Onclick()
	setDeadpoolBets(DeadpoolGlobal_SessionId, Deadpool_playerCharacter(),
		DeadpoolSummaryFrameTargetTitleText:GetText(),
			DeadpoolSummaryFrameTargetNextDeathBet:GetText())
end

function DeadpoolFrameSummaryButton_Onclick()
	local point, relativeTo, relativePoint, xOffset, yOffset = DeadpoolFrame:GetPoint(index)
	local frameOffset = DeadpoolSummaryFrame:GetWidth() + 1
	if DeadpoolSummaryFrame:IsShown() then
		DeadpoolFrame:SetWidth(DEADPOOL_ALLCOLS_WIDTH + 24 + 30)
		DeadpoolSummaryFrame:Hide()
		_G["DeadpoolFrameSummaryButtonArrow-Right"]:Show()
		_G["DeadpoolFrameSummaryButtonArrow-Left"]:Hide()
		if point == "CENTER" or point == "BOTTOM" or point == "TOP" then
			DeadpoolFrame:SetPoint(point, relativeTo, relativePoint, xOffset - frameOffset/2, yOffset)
		else
			if string.find(point, "RIGHT") then
				DeadpoolFrame:SetPoint(point, relativeTo, relativePoint, xOffset - frameOffset, yOffset)
			end
		end
	else
		DeadpoolFrame:SetWidth(DeadpoolFrame:GetWidth() + frameOffset)
		DeadpoolSummaryFrame:Show()
		_G["DeadpoolFrameSummaryButtonArrow-Right"]:Hide()
		_G["DeadpoolFrameSummaryButtonArrow-Left"]:Show()
		if point == "CENTER" or point == "BOTTOM" or point == "TOP" then
			DeadpoolFrame:SetPoint(point, relativeTo, relativePoint, xOffset + frameOffset/2, yOffset)
		else
			if string.find(point, "RIGHT") then
				DeadpoolFrame:SetPoint(point, relativeTo, relativePoint, xOffset + frameOffset, yOffset)
			end
		end
		--if selectedDeadpoolLine then
			--PanelTemplates_SetTab(DeadpoolSummaryFrame, 2)
			--PanelTemplates_Tab_OnClick(DeadpoolSummaryFrameTab2, DeadpoolSummaryFrame)
			--DeadpoolSummaryFrame_Update()
		--end
		DeadpoolSummaryFrame_Update()
	end
end

function createAnnounceDeadpoolSessionButton(parent)
	local name = "SessionTitleButton"
	local iconPath = "Interface\\BUTTONS\\UI-GuildButton-MOTD-Up"
	local tooltip = L["ANNOUNCEDEADPOOLSESSIONBUTTON_TOOLTIP"]
	local tooltipDetail = L["ANNOUNCEDEADPOOLSESSIONBUTTON_TOOLTIPDETAIL"]

	local announceDeadpoolSessionButton = CreateFrame("Button", name, parent, "AnnounceDeadpoolSessionButtonTemplate")
	announceDeadpoolSessionButton:SetPoint("TOPRIGHT", -51, -3)
	announceDeadpoolSessionButton:SetNormalTexture(iconPath)
	announceDeadpoolSessionButton:SetAttribute("tooltip", tooltip)
	announceDeadpoolSessionButton:SetAttribute("tooltipDetail", { tooltipDetail })

	return announceDeadpoolSessionButton
end

function createDeadpoolOptionsButton(parent)
	local name = "DeadpoolOptionsButton"
	local iconPath = "Interface\\GossipFrame\\BinderGossipIcon"
	local tooltip = L["MENUOPTIONS_TOOLTIP"]
	local tooltipDetail = L["MENUOPTIONS_TOOLTIPDETAIL"]

	local optionsButton = CreateFrame("Button", name, parent, "DeadpoolOptionsButtonTemplate")
	optionsButton:SetPoint("TOPRIGHT", -30, -3)
	optionsButton:SetNormalTexture(iconPath)
	optionsButton:SetAttribute("tooltip", tooltip)
	optionsButton:SetAttribute("tooltipDetail", { tooltipDetail })

	return optionsButton
end

function createDeadpoolSearchBox(parent)
	local name = "DeadpoolSearchBox"
	local searchBox = CreateFrame("EditBox", name, parent, "DeadpoolSearchBoxTemplate")
	searchBox:SetPoint("TOPLEFT", 5, -2)
	
	return searchBox
end

function createDeadpoolRoleButton(aDeadpoolSessionId, fullName, indexCharac, xValue, deadpoolLine)
	local portraitButton = getElementFromDeadpoolFramePool("Button", indexCharac,
		"DeadpoolPortrait"..indexCharac, "PortraitButtonTemplate", deadpoolLine:GetName())
	portraitButton:SetAttribute("tooltip", fullName)
	portraitButton:SetPoint("LEFT", xValue, 0)
	portraitButton:SetHeight(DeadpoolOptionsData["DeadpoolLigneHeight"] - 2)
	portraitButton:SetWidth(DeadpoolOptionsData["DeadpoolLigneHeight"] - 2)
	portraitButton.CircleGlow:SetHeight(DeadpoolOptionsData["DeadpoolLigneHeight"] - 2 + 10)
	portraitButton.CircleGlow:SetWidth(DeadpoolOptionsData["DeadpoolLigneHeight"] - 2 + 10)
	local portraitButtonTexture = _G["DeadpoolPortrait"..indexCharac.."Texture"]
	if not portraitButtonTexture then
		portraitButtonTexture = portraitButton:CreateTexture("DeadpoolPortrait"..indexCharac.."Texture", "BACKGROUND")
	end
	portraitButtonTexture:SetHeight(DeadpoolOptionsData["DeadpoolLigneHeight"] - 2)
	portraitButtonTexture:SetWidth(DeadpoolOptionsData["DeadpoolLigneHeight"] - 2)
	portraitButtonTexture:SetPoint("CENTER", 0, 0)
	SetPortraitTexture(portraitButtonTexture, deadpoolCharInfo[fullName]["groupRank"])
	if getDeadpoolData(aDeadpoolSessionId, fullName, "credits") then
		portraitButton.CircleGlow:Show()
		portraitButton:SetAttribute("tooltipDetailGreen", { L["DEADPOOLUI_PLAYINGDEADPOOL"] })
	else
		portraitButton.CircleGlow:Hide()
		portraitButton:SetAttribute("tooltipDetailGreen", nil)
	end

	local roleButtonSize = floor((DeadpoolOptionsData["DeadpoolLigneHeight"] - 2)/2)
	local roleButton = getElementFromDeadpoolFramePool("Button", indexCharac,
		"DeadpoolRole"..indexCharac, "RoleButtonTemplate", "DeadpoolPortrait"..indexCharac)
	roleButton:SetPoint("BOTTOMRIGHT", 5, -3)
	roleButton:SetHeight(roleButtonSize)
	roleButton:SetWidth(roleButtonSize)
	roleButton:SetNormalTexture(getDeadpoolRoleTexture(deadpoolCharInfo[fullName]["groupRole"], roleButton, indexCharac, roleButtonSize))
   	roleButton:SetAttribute("fullName", fullName)
	return portraitButton, role
end

function getDeadpoolRoleTexture(role, roleButton, indexCharac, texSize)
	local texture = _G[role.."RoleTexture"]
	if not texture then
		texture = roleButton:CreateTexture(role.."RoleTexture"..indexCharac, "BACKGROUND", role.."RoleTextureTemplate")
	end
	if texSize then
		texture:SetHeight(texSize)
		texture:SetWidth(texSize)
	end
	return texture
end

function DeadpoolSummaryFrame_Update()
	if DeadpoolSummaryFrame:IsShown() then
		local selectedTab = PanelTemplates_GetSelectedTab(DeadpoolSummaryFrame)
		if ( selectedTab == 1 ) then
			DeadpoolSummaryFrameTarget:Show()
			DeadpoolSummaryFramePlayer:Hide()
			if selectedDeadpoolCharacter and deadpoolCharInfo[selectedDeadpoolCharacter] then
				DeadpoolSummaryFrameTargetTitleText:SetText(selectedDeadpoolCharacter)
				local nextDeathBet = getDeadpoolBets(DeadpoolGlobal_SessionId, Deadpool_playerCharacter(), selectedDeadpoolCharacter)
				if not GetCurrentKeyBoardFocus() or not (DeadpoolSummaryFrameTargetNextDeathBet == GetCurrentKeyBoardFocus()) then
					DeadpoolSummaryFrameTargetNextDeathBet:SetText(nextDeathBet)
				end
				DeadpoolSummaryFrameTargetNextDeathBet:Show()
				DeadpoolSummaryFrameTargetNextDeathBetLabel:Show()
				ValidateBetButton:Show()
			else
				DeadpoolSummaryFrameTargetTitleText:SetText(L["NO_SELECTED_CHARACTER"])
				DeadpoolSummaryFrameTargetNextDeathBet:Hide()
				DeadpoolSummaryFrameTargetNextDeathBetLabel:Hide()
				DeadpoolSideDressUpModelTarget:Hide()
				ValidateBetButton:Hide()
			end
		else
			DeadpoolSummaryFrameTarget:Hide()
			DeadpoolSummaryFramePlayer:Show()
			if selectedDeadpoolCharacter and deadpoolCharInfo[selectedDeadpoolCharacter] then
				local groupRank = deadpoolCharInfo[selectedDeadpoolCharacter]["groupRank"]
				if groupRank then
					if groupRank ~= "player" and not UnitIsVisible(groupRank) then
						DeadpoolSideDressUpModelTarget:SetUnit("player")
						DeadpoolSideDressUpModelTarget:SetCustomRace(
							deadpoolCharInfo[selectedDeadpoolCharacter]["race"], deadpoolCharInfo[selectedDeadpoolCharacter]["gender"])
						Deadpool_customDressing(DeadpoolSideDressUpModelTarget)
					else
						DeadpoolSideDressUpModelTarget:SetUnit(groupRank)
					end
					deadpoolUndressModel(DeadpoolSideDressUpModelTarget,
						Deadpool_tonumberzeroonblankornil(getDeadpoolData(DeadpoolGlobal_SessionId, selectedDeadpoolCharacter, "offItemsNumber")))
				end
				DeadpoolSideDressUpModelTarget:Show()
			end
		end
	end
end

function Deadpool_customDressing(aModel)
	aModel:Undress()
	aModel:TryOn("item:"..54451) -- Head : High Society Top Hat
	aModel:TryOn("item:"..33122) -- Back : Cloak of Darkness
	aModel:TryOn("item:"..51971) -- Waist : Enumerated Belt
	aModel:TryOn("item:"..24755) -- Shoulder : Daggerfen Pauldrons
	aModel:TryOn("item:"..116134) -- Feet : Noble's Fancy Boots
	aModel:TryOn("item:"..24365) -- Hand : Deft Handguards
	aModel:TryOn("item:"..24684) -- Wrist : Archmage Bracelets
	aModel:TryOn("item:"..116052) -- Chest : Nobleman's Coat
	aModel:TryOn("item:"..116133) -- Legs : Nobleman's Pantaloons
end

function generateDeadpoolTable()
	deadpoolCharInfo = getDeadpoolRosterInfo()
	if DeadpoolFrame and DeadpoolFrame:IsShown() then
		local searchBoxText = ""
		if _G["DeadpoolSearchBox"] then
			searchBoxText = string.upper(_G["DeadpoolSearchBox"]:GetText())
		end

		-- Characters sorting
		local charNames = {}
		charNames[ 1 ] = ""
		for k in pairs(deadpoolCharInfo) do
			if not Deadpool_isPlayerCharacter(k) then
				charNames[ #charNames + 1 ] = k
			end
		end
		table.sort(charNames)

		charNames[ 1 ] = Deadpool_playerCharacter()
		deadpoolList = {}

		local indexCharac = 0
		for k,v in pairs(charNames) do
			if string.find(string.upper(Deadpool_delRealm(v)), searchBoxText) then -- Search box result
				table.insert(deadpoolList, v)
			end
		end
		Deadpool_UpdateScrollFrame(_G["DeadpoolScrollFrame"])

		local credits = Deadpool_tonumberzeroonblankornil(getDeadpoolData(DeadpoolGlobal_SessionId, Deadpool_playerCharacter(), "credits"))
		DeadpoolPlayerCreditsCount:SetText(credits)

		credits = Deadpool_tonumberzeroonblankornil(getDeadpoolData(DeadpoolGlobal_SessionId, "Bank", "credits"))
		DeadpoolBankCreditsCount:SetText(credits)

		local totalNextDeathBets, nbNextDeathBets = getDeadpoolTotalBets(DeadpoolGlobal_SessionId, "nextDeathBet")
		DeadpoolBetsCreditsCount:SetText(totalNextDeathBets)
	end
	DeadpoolSummaryFrame_Update()
end

function Deadpool_UpdateScrollFrame(self)
    local numItems = Deadpool_countTableElements(deadpoolList)
    FauxScrollFrame_Update(self, numItems, DEADPOOL_NUM_LINES, DeadpoolOptionsData["DeadpoolLigneHeight"])
    local offset = FauxScrollFrame_GetOffset(self)
    for line = 1, DEADPOOL_NUM_LINES do
        local lineplusoffset = line + offset
        local deadpoolLine = deadpoolLines[line]
		deadpoolLine:SetHeight(DeadpoolOptionsData["DeadpoolLigneHeight"])
        if lineplusoffset > numItems then
            deadpoolLine:Hide()
        else
            createDeadpoolLine(DeadpoolGlobal_SessionId, line, deadpoolList[lineplusoffset], deadpoolLine)
            deadpoolLine:Show()
        end
    end
	DeadpoolFrameInsideFrame:SetWidth(DEADPOOL_ALLCOLS_WIDTH + 16 + 30)
	local numLines = 10
	if numItems < numLines then
		numLines = numItems
	end
	
	local linesHeight = DeadpoolOptionsData["DeadpoolLigneHeight"] * numLines
	local minimumHeight = 50
	if linesHeight < minimumHeight then
		linesHeight = minimumHeight
	end
	DeadpoolFrameInsideFrame:SetHeight(linesHeight + 9)
	DeadpoolFrame:SetHeight(60 + linesHeight + 19)
	DeadpoolSummaryFrame:SetHeight(linesHeight + 29)
	DeadpoolSideDressUpModelTarget:SetHeight(linesHeight + 19)
	local modelWidth = floor((linesHeight + 19) * 1.5)
	local maximumWidth = 160
	if modelWidth > maximumWidth then
		modelWidth = maximumWidth
	end
	DeadpoolSideDressUpModelTarget:SetWidth(modelWidth)
end

function DeadpoolFrameTemplate_OnEnter(self)
	if DeadpoolOptionsData
		and DeadpoolOptionsData["DeadpoolFrameAlpha"]
			and DeadpoolOptionsData["DeadpoolFrameAlpha"] < 0.7 then
		self:SetAlpha(0.7)
	end
end
				
function DeadpoolFrameTemplate_OnLeave(self)
	if DeadpoolOptionsData and DeadpoolOptionsData["DeadpoolFrameAlpha"] then
		if not MouseIsOver(self) then
			self:SetAlpha(DeadpoolOptionsData["DeadpoolFrameAlpha"])
		end
	end
end

-- TOASTS - Thanks to Tuhljin from Overachiever !
-----------

local fakeToastBaseID
local fakeToastName

local function achievementToasted(frame, achievementID, alreadyEarned)
	if (achievementID == fakeToastBaseID) then
		frame.Name:SetText(fakeToastName)
		fakeToastBaseID = nil
	fakeToastName = nil
	end
end

local hookedAchToast = false
function Deadpool.ToastFakeAchievement(title, baseID)
	local temp = ACHIEVEMENT_UNLOCKED
	ACHIEVEMENT_UNLOCKED = "Dead Pool"

	if ( not AchievementFrame ) then
		AchievementFrame_LoadUI();
	end

	if (not hookedAchToast) then
		hooksecurefunc(AchievementAlertSystem, "setUpFunction", achievementToasted)
		hookedAchToast = true
	end

	if (not baseID) then baseID = 5208; end -- 5208 is "Twin Peaking", chosen because of its thumbs-up art.
	fakeToastName = title
	fakeToastBaseID = baseID
	AchievementAlertSystem:AddAlert(baseID, true) -- Flagging it as already earned gives more space for the text to display since there's no shield+points icon
	
	local achievementAlertPool = AchievementAlertSystem.alertFramePool
	for alertFrame in achievementAlertPool:EnumerateActive() do
		alertFrame:SetScript("OnClick", function() Deadpool:DeadpoolShow() end)
	end

	ACHIEVEMENT_UNLOCKED = temp
end

-- NPC dialog pop-up
-----------

function tellTutorialText(text, force)
	if text and (DeadpoolFrame:IsShown() or force)
		and not DeadpoolOptionsData["TutoDisabled"]
			and (not DeadpoolTuto or not DeadpoolTuto[text]) then
		if ( not TalkingHeadFrame ) then
			TalkingHead_LoadUI()
		end

		local frame = TalkingHeadFrame
		local model = frame.MainFrame.Model

		model:ClearModel()
		model:SetDisplayInfo(75730)
		Deadpool_TalkingHeadFrame_Play(114, L["GALLYWIX"], L[text])

		Deadpool_PlaySoundFile(text)

		DeadpoolTuto[text] = "done"
	end
end

function Deadpool_TalkingHeadFrame_Play(cameraId, name, text)
	local frame = TalkingHeadFrame
	local model = frame.MainFrame.Model
	
	local currentDisplayInfo = model:GetDisplayInfo()
	local textFormatted = string.format(text)
	frame:Show()
	model.uiCameraID = cameraId
	Model_ApplyUICamera(model, model.uiCameraID)

	TalkingHeadFrame_Reset(frame, textFormatted, name)
	TalkingHeadFrame_FadeinFrames()
end
